/**
 * Enum of all token types, with bit fields to signify meaningful properties.
 */
export declare const enum TokenType {
    PRECEDENCE_MASK = 15,
    IS_KEYWORD = 16,
    IS_ASSIGN = 32,
    IS_RIGHT_ASSOCIATIVE = 64,
    IS_PREFIX = 128,
    IS_POSTFIX = 256,
    num = 0,
    bigint = 512,
    regexp = 1024,
    string = 1536,
    name = 2048,
    eof = 2560,
    bracketL = 3072,
    bracketR = 3584,
    braceL = 4096,
    braceBarL = 4608,
    braceR = 5120,
    braceBarR = 5632,
    parenL = 6144,
    parenR = 6656,
    comma = 7168,
    semi = 7680,
    colon = 8192,
    doubleColon = 8704,
    dot = 9216,
    question = 9728,
    questionDot = 10240,
    arrow = 10752,
    template = 11264,
    ellipsis = 11776,
    backQuote = 12288,
    dollarBraceL = 12800,
    at = 13312,
    hash = 13824,
    eq = 14368,
    assign = 14880,
    incDec = 15744,
    bang = 16000,
    tilde = 16512,
    pipeline = 16897,
    nullishCoalescing = 17410,
    logicalOR = 17922,
    logicalAND = 18435,
    bitwiseOR = 18948,
    bitwiseXOR = 19461,
    bitwiseAND = 19974,
    equality = 20487,
    lessThan = 21000,
    greaterThan = 21512,
    relationalOrEqual = 22024,
    bitShift = 22537,
    plus = 23178,
    minus = 23690,
    modulo = 24075,
    star = 24587,
    slash = 25099,
    exponent = 25676,
    jsxName = 26112,
    jsxText = 26624,
    jsxTagStart = 27136,
    jsxTagEnd = 27648,
    typeParameterStart = 28160,
    nonNullAssertion = 28672,
    _break = 29200,
    _case = 29712,
    _catch = 30224,
    _continue = 30736,
    _debugger = 31248,
    _default = 31760,
    _do = 32272,
    _else = 32784,
    _finally = 33296,
    _for = 33808,
    _function = 34320,
    _if = 34832,
    _return = 35344,
    _switch = 35856,
    _throw = 36496,
    _try = 36880,
    _var = 37392,
    _let = 37904,
    _const = 38416,
    _while = 38928,
    _with = 39440,
    _new = 39952,
    _this = 40464,
    _super = 40976,
    _class = 41488,
    _extends = 42000,
    _export = 42512,
    _import = 43024,
    _yield = 43536,
    _null = 44048,
    _true = 44560,
    _false = 45072,
    _in = 45592,
    _instanceof = 46104,
    _typeof = 46736,
    _void = 47248,
    _delete = 47760,
    _async = 48144,
    _get = 48656,
    _set = 49168,
    _declare = 49680,
    _readonly = 50192,
    _abstract = 50704,
    _static = 51216,
    _public = 51728,
    _private = 52240,
    _protected = 52752,
    _as = 53264,
    _enum = 53776,
    _type = 54288,
    _implements = 54800
}
export declare function formatTokenType(tokenType: TokenType): string;
