import TokenProcessor from "../TokenProcessor";
import Transformer from "./Transformer";
/**
 * Class for editing import statements when we are keeping the code as ESM. We still need to remove
 * type-only imports in TypeScript and Flow.
 */
export default class ESMImportTransformer extends Transformer {
    readonly tokens: TokenProcessor;
    readonly isTypeScriptTransformEnabled: boolean;
    private nonTypeIdentifiers;
    constructor(tokens: TokenProcessor, isTypeScriptTransformEnabled: boolean);
    process(): boolean;
    private processImport;
    /**
     * Remove type bindings from this import, leaving the rest of the import intact.
     *
     * Return true if this import was ONLY types, and thus is eligible for removal. This will bail out
     * of the replacement operation, so we can return early here.
     */
    private removeTypeBindings;
    private isTypeName;
}
