import CJSImportProcessor from "../CJSImportProcessor";
import { Options } from "../index";
import NameManager from "../NameManager";
import TokenProcessor from "../TokenProcessor";
import RootTransformer from "./RootTransformer";
import Transformer from "./Transformer";
export default class JSXTransformer extends Transformer {
    readonly rootTransformer: RootTransformer;
    readonly tokens: TokenProcessor;
    readonly importProcessor: CJSImportProcessor | null;
    readonly nameManager: NameManager;
    readonly options: Options;
    lastLineNumber: number;
    lastIndex: number;
    filenameVarName: string | null;
    readonly jsxPragmaBase: string;
    readonly jsxPragmaSuffix: string;
    readonly jsxFragmentPragmaBase: string;
    readonly jsxFragmentPragmaSuffix: string;
    constructor(rootTransformer: RootTransformer, tokens: TokenProcessor, importProcessor: CJSImportProcessor | null, nameManager: NameManager, options: Options);
    private splitPragma;
    process(): boolean;
    getPrefixCode(): string;
    /**
     * Lazily calculate line numbers to avoid unneeded work. We assume this is always called in
     * increasing order by index.
     */
    getLineNumberForIndex(index: number): number;
    getFilenameVarName(): string;
    processProps(firstTokenStart: number): void;
    processStringPropValue(): void;
    /**
     * Process the first part of a tag, before any props.
     */
    processTagIntro(): void;
    processChildren(): void;
    processChildTextElement(): void;
    processJSXTag(): void;
}
export declare function startsWithLowerCase(s: string): boolean;
